commit 644d33854a7dea939d8ebf8ac009a5d0a757f1a7
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Thu Jul 25 17:02:52 2019 +0200

    USE-Einleitungen formatiert templates/webpages/client_config/

diff --git a/templates/webpages/client_config/_attachments.html b/templates/webpages/client_config/_attachments.html
index 9d1cc73f2..cdec1faac 100644
--- a/templates/webpages/client_config/_attachments.html
+++ b/templates/webpages/client_config/_attachments.html
@@ -1,4 +1,6 @@
-[%- USE LxERP -%][%- USE L -%]
+[% USE LxERP %]
+[% USE L %]
+
 <div id="attachments">
 [% SET file_type = 'attachment' %]
 [% INCLUDE 'file/rename_dialog.html' %]
diff --git a/templates/webpages/client_config/_datev_check_configuration.html b/templates/webpages/client_config/_datev_check_configuration.html
index dc99c218e..41eac194a 100644
--- a/templates/webpages/client_config/_datev_check_configuration.html
+++ b/templates/webpages/client_config/_datev_check_configuration.html
@@ -1,4 +1,6 @@
-[%- USE LxERP -%][%- USE L -%]
+[% USE LxERP %]
+[% USE L %]
+
 <div id="datev_check_configuration">
  <table>
   <tr>
diff --git a/templates/webpages/client_config/_default_accounts.html b/templates/webpages/client_config/_default_accounts.html
index 35a8a3a70..02344a38e 100644
--- a/templates/webpages/client_config/_default_accounts.html
+++ b/templates/webpages/client_config/_default_accounts.html
@@ -1,4 +1,3 @@
-[%- USE HTML -%][%- USE LxERP -%][%- USE L -%][%- USE P -%][%- USE T8 -%]
 [% SET style="width: 500px" %]
 [%# L.dump( SELF.defaults ) %]
 <div id="default_accounts">
@@ -24,6 +23,11 @@
    <td align="right">[% LxERP.t8("Foreign Exchange Gain") %]</td>
    <td>[% P.chart.picker('defaults.fxgain_accno_id', SELF.defaults.fxgain_accno_id, category='I,A', choose=1, style=style) %]<td>
   </tr>
+[% USE HTML %]
+[% USE LxERP %]
+[% USE L %]
+[% USE T8 %]
+[% USE P %]
 
   <tr>
    <td align="right">[% LxERP.t8("Foreign Exchange Loss") %]</td>
diff --git a/templates/webpages/client_config/_features.html b/templates/webpages/client_config/_features.html
index ec622e5a8..c791cc1f0 100644
--- a/templates/webpages/client_config/_features.html
+++ b/templates/webpages/client_config/_features.html
@@ -1,4 +1,3 @@
-[%- USE LxERP -%][%- USE L -%][%- USE P -%][%- USE T8 %]
 [% SET style="width: 250px" %]
 <div id="features">
  <table>
@@ -203,6 +202,10 @@
    <td>[% L.yes_no_tag('defaults.allow_sales_invoice_from_sales_quotation', SELF.defaults.allow_sales_invoice_from_sales_quotation) %]</td>
    <td>[% LxERP.t8('If disabled sales quotations cannot be converted into sales invoices directly.') %]</td>
   </tr>
+[% USE LxERP %]
+[% USE L %]
+[% USE P %]
+[% USE T8 %]
 
   <tr>
    <td align="right">[% LxERP.t8('Allow conversion from sales orders to sales invoices') %]</td>
diff --git a/templates/webpages/client_config/_miscellaneous.html b/templates/webpages/client_config/_miscellaneous.html
index f938f7268..d834c02a8 100644
--- a/templates/webpages/client_config/_miscellaneous.html
+++ b/templates/webpages/client_config/_miscellaneous.html
@@ -1,4 +1,3 @@
-[%- USE LxERP -%][%- USE L -%][%- USE HTML -%]
 [% SET style="width: 400px" %]
 <div id="miscellaneous">
  <table>
@@ -74,6 +73,10 @@
    <td align="right">[% LxERP.t8('Default Customer/Vendor Language') %]</td>
    <td>[% L.select_tag('defaults.language_id', SELF.all_languages, title_key='description', default=SELF.defaults.language_id, with_empty=1, style=style) %]</td>
   </tr>
+[% USE LxERP %]
+[% USE L %]
+[% USE HTML %]
+[% USE T8 %]
 
   <tr><td class="listheading" colspan="4">[% LxERP.t8("Print templates") %]</td></tr>
 
diff --git a/templates/webpages/client_config/_orders_deleteable.html b/templates/webpages/client_config/_orders_deleteable.html
index 0b35a72ee..e386e9ad0 100644
--- a/templates/webpages/client_config/_orders_deleteable.html
+++ b/templates/webpages/client_config/_orders_deleteable.html
@@ -1,4 +1,7 @@
-[%- USE LxERP -%][%- USE L -%]
+[% USE LxERP %]
+[% USE L %]
+[% USE T8 %]
+
 <div id="orders_deleteable">
  <table>
   <tr>
diff --git a/templates/webpages/client_config/_posting_configuration.html b/templates/webpages/client_config/_posting_configuration.html
index 824c9393c..c5b190c1c 100644
--- a/templates/webpages/client_config/_posting_configuration.html
+++ b/templates/webpages/client_config/_posting_configuration.html
@@ -1,4 +1,7 @@
-[%- USE L -%][%- USE LxERP -%]
+[% USE L %]
+[% USE LxERP %]
+[% USE T8 %]
+
 <div id="posting_configuration">
  <table>
   <tr>
diff --git a/templates/webpages/client_config/_ranges_of_numbers.html b/templates/webpages/client_config/_ranges_of_numbers.html
index 90c075168..a04cb8092 100644
--- a/templates/webpages/client_config/_ranges_of_numbers.html
+++ b/templates/webpages/client_config/_ranges_of_numbers.html
@@ -1,4 +1,3 @@
-[%- USE LxERP -%][%- USE L -%][%- USE HTML -%]
 <div id="ranges_of_numbers">
  <table>
   <tr>
@@ -14,6 +13,10 @@
    <td align="right" nowrap>[% LxERP.t8('Last Vendor Number') %]</td>
    <td>[% L.input_tag("defaults.vendornumber", SELF.defaults.vendornumber, size="15") %]</td>
   </tr>
+[% USE LxERP %]
+[% USE L %]
+[% USE HTML %]
+[% USE T8 %]
 
   <tr>
    <td align="right" nowrap>[% LxERP.t8('Last Sales Order Number') %]</td>
diff --git a/templates/webpages/client_config/_stocktaking.html b/templates/webpages/client_config/_stocktaking.html
index d95d2a51f..50dc09361 100644
--- a/templates/webpages/client_config/_stocktaking.html
+++ b/templates/webpages/client_config/_stocktaking.html
@@ -1,4 +1,3 @@
-[%- USE HTML -%][%- USE LxERP -%][%- USE L -%]
 <div id="stocktaking">
  <table>
   <tr>
@@ -34,6 +33,10 @@
    </td>
   </tr>
   <tr>
+[% USE HTML %]
+[% USE LxERP %]
+[% USE L %]
+[% USE T8 %]
 
   <tr>
    <td align="right" nowrap="true">[% LxERP.t8('Threshold for warning on quantity difference') %]</td>
diff --git a/templates/webpages/client_config/_warehouse.html b/templates/webpages/client_config/_warehouse.html
index 3cc28efa0..162b85b08 100644
--- a/templates/webpages/client_config/_warehouse.html
+++ b/templates/webpages/client_config/_warehouse.html
@@ -1,4 +1,8 @@
-[%- USE HTML -%][%- USE LxERP -%][%- USE L -%]
+[% USE HTML %]
+[% USE LxERP %]
+[% USE L %]
+[% USE T8 %]
+
 <div id="warehouse">
  <table>
   <tr>
diff --git a/templates/webpages/client_config/form.html b/templates/webpages/client_config/form.html
index dcb5576c7..dd9719a0b 100644
--- a/templates/webpages/client_config/form.html
+++ b/templates/webpages/client_config/form.html
@@ -1,4 +1,3 @@
-[%- USE L %][% USE LxERP %][% USE HTML %][%- USE JavaScript -%]
  <script type="text/javascript" src="js/common.js"></script>
  <script type="text/javascript">
   <!--
@@ -47,6 +46,12 @@ function verifyMBSize(elem) {
 function verifyRootPath(elem) {
   if ( elem.value == "" ) {
     elem.value="./documents";
+[% USE L %]
+[% USE LxERP %]
+[% USE HTML %]
+[% USE JavaScript %]
+[% USE T8 %]
+
   }
 }
 