commit 677f0dd53d5f964fb4e69eaf7236ffb6a830568b
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Fri Oct 22 17:40:00 2021 +0200

    Ein-/Verkauf: Belegnummern von uns erzeugter Belege nicht ändern können
    
    Für Belege, die auf unserer Seite erzeugt werden, kann nun verhindert
    werden, dass die Belegnummer manuell angepasst bzw. gesetzt
    wird. Statt dessen wird sie immer vom System beim ersten Speichern
    vergeben und beim späteren Bearbeiten nur noch read-only angezeigt.
    
    Betrifft alle Verkaufsbelege sowie Preisanfragen & Lieferantenaufträge
    im Einkaufsbereich.

diff --git a/SL/DB/MetaSetup/Default.pm b/SL/DB/MetaSetup/Default.pm
index 86da0f835..406105145 100644
--- a/SL/DB/MetaSetup/Default.pm
+++ b/SL/DB/MetaSetup/Default.pm
@@ -157,6 +157,7 @@ __PACKAGE__->meta->columns(
   sales_delivery_order_show_delete          => { type => 'boolean', default => 'true' },
   sales_order_show_delete                   => { type => 'boolean', default => 'true' },
   sales_purchase_order_ship_missing_column  => { type => 'boolean', default => 'false' },
+  sales_purchase_record_numbers_changeable  => { type => 'boolean', default => 'false', not_null => 1 },
   sales_serial_eq_charge                    => { type => 'boolean', default => 'false', not_null => 1 },
   sdonumber                                 => { type => 'text' },
   sepa_creditor_id                          => { type => 'text' },
diff --git a/doc/changelog b/doc/changelog
index 9443ffd93..67c9c4297 100644
--- a/doc/changelog
+++ b/doc/changelog
@@ -39,6 +39,10 @@ Kleinere neue Features und Detailverbesserungen:
   Platzhalter enthalten, die vom Beleg selber stammen. So könnte
   z.B. in der Artikelbeschreibung automatisch die Rechnungsnummer
   ersetzt werden. Beispiel: »Abrechnungszeitraum bis <%invnumber%>«
+- Verkaufs- & Einkaufsbelege: kivitendo kann so konfiguriert werden,
+  dass die Belegnummern von Belegen, die auf unserer Seite erzeugt
+  werden, nicht mehr editierbar sind. In dem Fall vergibt kivitendo
+  sie immer automatisch und zeigt sie in den Belegmasken nur noch an.
 
 Bugfixes (Tracker: https://www.kivitendo.de/redmine):
 
diff --git a/locale/de/all b/locale/de/all
index 291b30ad1..12aa6bbe5 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -1690,6 +1690,7 @@ $self->{texts} = {
   'If disabled purchase invoices can only be created by conversion from existing requests for quotations, purchase orders and purchase delivery orders.' => 'Falls deaktiviert, so können Einkaufsrechnungen nur durch Umwandlung aus bestehenden Preisanfragen, Lieferantenaufträgen und Einkaufslieferscheinen angelegt werden.',
   'If disabled sales orders cannot be converted into sales invoices directly.' => 'Falls deaktiviert, so können Verkaufsaufträge nicht direkt in Verkaufsrechnungen umgewandelt werden.',
   'If disabled sales quotations cannot be converted into sales invoices directly.' => 'Falls deaktiviert, so können Verkaufsangebote nicht direkt in Verkaufsrechnungen umgewandelt werden.',
+  'If disabled, record numbers for sales records & purchase records produced by our side will always be auto-generated and cannot be changed later.' => 'Falls deaktiviert, werden Belegnummern in Verkaufs- und Einkaufsbelegen, die auf unserer Seite erzeugt wurden, immer automatisch vergeben und können anschließend nicht mehr geändert werden.',
   'If enabled Factur-X/ZUGFeRD conformant sales invoice PDFs will be created.' => 'Falls aktiviert, werden Factur-X-/ZUGFeRD-konforme PDFs für Verkaufsrechnungen erzeugt.',
   'If enabled a column will be shown in sales and purchase orders that lists both the amount and the value not shipped yet for each item.' => 'Falls eingeschaltet, wird für jede Position in Auftragsbestätigungen und Lieferantenaufträgen eine Spalte mit noch nicht gelieferter Menge und Wert angezeigt.',
   'If enabled a warning will be shown if a sales invoices is created without having a sales delivery order as a predecessor.' => 'Falls aktiv, wird eine Warnung beim Buchen einer Verkaufsrechnung angezeigt, falls es keinen Lieferschein als Vorgänger gibt.',
@@ -2744,6 +2745,7 @@ $self->{texts} = {
   'Record Vendor Invoice'       => 'Einkaufsrechnung erfassen',
   'Record in'                   => 'Buchen auf',
   'Record number'               => 'Belegnummer',
+  'Record numbers changeable'   => 'Änderbarkeit von Belegnummern',
   'Record templates'            => 'Belegvorlagen',
   'Record type to create'       => 'Anzulegender Belegtyp',
   'Record\'s files'             => 'Belegdateien',
@@ -4542,6 +4544,8 @@ $self->{texts} = {
   'warehouse_journal_list'      => 'lagerbuchungsliste',
   'warehouse_report_list'       => 'lagerbestandsliste',
   'warehouse_usage_list'        => 'Lagerentnahmeliste',
+  'will be set upon posting'    => 'wird beim Buchen vergeben',
+  'will be set upon saving'     => 'wird beim Speichern vergeben',
   'with skonto acc. to pt'      => 'mit Skonto nach ZB',
   'with_skonto_pt'              => 'mit Skonto nach ZB',
   'without skonto'              => 'ohne Skonto',
diff --git a/sql/Pg-upgrade2/defaults_sales_purchase_record_numbers_changeable.sql b/sql/Pg-upgrade2/defaults_sales_purchase_record_numbers_changeable.sql
new file mode 100644
index 000000000..d7dce5519
--- /dev/null
+++ b/sql/Pg-upgrade2/defaults_sales_purchase_record_numbers_changeable.sql
@@ -0,0 +1,6 @@
+-- @tag: defaults_sales_purchase_record_numbers_changeable
+-- @description: Verkauf: Belegnummern nicht mehr ändern können
+-- @depends: release_3_5_8
+ALTER TABLE defaults
+ADD COLUMN sales_purchase_record_numbers_changeable BOOLEAN
+DEFAULT FALSE NOT NULL;
diff --git a/templates/webpages/client_config/_posting_configuration.html b/templates/webpages/client_config/_posting_configuration.html
index a481639ab..0235cc3e1 100644
--- a/templates/webpages/client_config/_posting_configuration.html
+++ b/templates/webpages/client_config/_posting_configuration.html
@@ -33,6 +33,11 @@
    <td>[% L.select_tag('defaults.payments_changeable', SELF.payment_options, value_key = 'value', title_key = 'title', default = SELF.defaults.payments_changeable) %]</td>
    <td>[% LxERP.t8('Should payments be and when should they be changeable after posting?') %]</td>
   </tr>
+  <tr>
+   <td align="right">[% LxERP.t8('Record numbers changeable') %]</td>
+   <td>[% L.yes_no_tag('defaults.sales_purchase_record_numbers_changeable', SELF.defaults.sales_purchase_record_numbers_changeable) %]</td>
+   <td>[% LxERP.t8('If disabled, record numbers for sales records & purchase records produced by our side will always be auto-generated and cannot be changed later.') %]</td>
+  </tr>
 
   <tr> </tr>
   <tr> </tr>
diff --git a/templates/webpages/do/form_header.html b/templates/webpages/do/form_header.html
index 9ff8e98a1..e5230f032 100644
--- a/templates/webpages/do/form_header.html
+++ b/templates/webpages/do/form_header.html
@@ -293,7 +293,16 @@
 
        <tr>
         <th width="70%" align="right" nowrap>[% 'Delivery Order Number' | $T8 %]</th>
-        <td><input name="donumber" id="donumber" size="11" value="[% HTML.escape(donumber) %]"[% RO %]></td>
+        <td>
+[%- IF !is_customer || INSTANCE_CONF.get_sales_purchase_record_numbers_changeable %]
+          [% L.input_tag("donumber", donumber, size="11", readonly=delivered) %]
+[%- ELSIF id %]
+          [% HTML.escape(donumber) %]
+          [% L.hidden_tag("donumber", donumber) %]
+[%- ELSE %]
+          [% LxERP.t8("will be set upon saving") %]
+[%- END %]
+        </td>
        </tr>
 
        <tr>
diff --git a/templates/webpages/is/form_header.html b/templates/webpages/is/form_header.html
index e61b175e8..3a3c17070 100644
--- a/templates/webpages/is/form_header.html
+++ b/templates/webpages/is/form_header.html
@@ -213,7 +213,16 @@
 [%- IF is_type_credit_note %]
         <tr>
           <th align="right" nowrap>[% 'Credit Note Number' | $T8 %]</th>
-          <td colspan="3"><input size='11' name="invnumber" id="invnumber" value="[% HTML.escape(invnumber) %]"></td>
+          <td colspan="3">
+[%- IF INSTANCE_CONF.get_sales_purchase_record_numbers_changeable %]
+            [% L.input_tag("invnumber", invnumber, size="11") %]
+[%- ELSIF id %]
+            [% L.hidden_tag("invnumber", invnumber) %]
+            [% HTML.escape(invnumber) %]
+[%- ELSE %]
+            [% LxERP.t8("will be set upon posting") %]
+[%- END %]
+          </td>
         </tr>
         <tr>
           <th align="right" nowrap>[% 'Invoice Number' | $T8 %]</th>
@@ -226,7 +235,16 @@
 [%- ELSE %]
         <tr>
           <th align="right" nowrap>[% 'Invoice Number' | $T8 %]</th>
-          <td colspan="3"><input size='11' name="invnumber" id="invnumber" value="[% HTML.escape(invnumber) %]"></td>
+          <td colspan="3">
+[%- IF INSTANCE_CONF.get_sales_purchase_record_numbers_changeable %]
+          [% L.input_tag("invnumber", invnumber, size="11") %]
+[%- ELSIF id %]
+            [% L.hidden_tag("invnumber", invnumber) %]
+            [% HTML.escape(invnumber) %]
+[%- ELSE %]
+            [% LxERP.t8("will be set upon posting") %]
+[%- END %]
+          </td>
         </tr>
         <tr>
           <th align="right">[% 'Invoice Date' | $T8 %]</th>
diff --git a/templates/webpages/oe/form_header.html b/templates/webpages/oe/form_header.html
index 2390718f3..e8325c35e 100644
--- a/templates/webpages/oe/form_header.html
+++ b/templates/webpages/oe/form_header.html
@@ -198,12 +198,30 @@
 [%- IF is_order %]
                   <tr>
                     <th width="70%" align="right" nowrap>[% 'Order Number' | $T8 %]</th>
-                    <td><input name="ordnumber" id="ordnumber" size="11" value="[% HTML.escape(ordnumber) %]"></td>
+                    <td>
+[%- IF INSTANCE_CONF.get_sales_purchase_record_numbers_changeable %]
+                      [% L.input_tag("ordnumber", ordnumber, size="11") %]
+[%- ELSIF id %]
+                      [% HTML.escape(ordnumber) %]
+                      [% L.hidden_tag("ordnumber", ordnumber) %]
+[%- ELSE %]
+                      [% LxERP.t8("will be set upon saving") %]
+[%- END %]
+                    </td>
                   </tr>
 [%- END %]
                   <tr>
                     <th width="70%" align="right" nowrap>[% IF is_req_quo %][% 'RFQ Number' | $T8 %][% ELSE %][% 'Quotation Number' | $T8 %][% END %]</th>
-                    <td><input name="quonumber" id="quonumber" size="11" value="[% HTML.escape(quonumber) %]"></td>
+                    <td>
+[%- IF is_order || INSTANCE_CONF.get_sales_purchase_record_numbers_changeable %]
+                      [% L.input_tag("quonumber", quonumber, size="11") %]
+[%- ELSIF id %]
+                      [% HTML.escape(quonumber) %]
+                      [% L.hidden_tag("quonumber", quonumber) %]
+[%- ELSE %]
+                      [% LxERP.t8("will be set upon saving") %]
+[%- END %]
+                    </td>
                   </tr>
 [%- IF is_order %]
                   <tr>
diff --git a/templates/webpages/order/tabs/basic_data.html b/templates/webpages/order/tabs/basic_data.html
index c4bcda06c..96ef3e79b 100644
--- a/templates/webpages/order/tabs/basic_data.html
+++ b/templates/webpages/order/tabs/basic_data.html
@@ -149,7 +149,16 @@
           [%- IF (SELF.type == "sales_order" || SELF.type == "purchase_order") -%]
           <tr>
             <th width="70%" align="right" nowrap>[% 'Order Number' | $T8 %]</th>
-            <td>[% L.input_tag('order.ordnumber', SELF.order.ordnumber, size = 11, onchange='kivi.Order.set_number_in_title(this)') %]</td>
+            <td>
+              [%- IF INSTANCE_CONF.get_sales_purchase_record_numbers_changeable %]
+                [% L.input_tag('order.ordnumber', SELF.order.ordnumber, size = 11, onchange='kivi.Order.set_number_in_title(this)') %]
+              [%- ELSIF SELF.order.id %]
+                [% HTML.escape(SELF.order.ordnumber) %]
+                [% L.hidden_tag("order.ordnumber", SELF.order.ordnumber) %]
+              [% ELSE %]
+                [% LxERP.t8("will be set upon saving") %]
+              [%- END %]
+            </td>
           </tr>
           [%- END -%]
 
@@ -160,11 +169,18 @@
           [%- END -%]
           <tr>
             <th width="70%" align="right" nowrap>[% quo_nr_txt | $T8 %]</th>
-            [%- IF (SELF.type == "sales_order" || SELF.type == "purchase_order") -%]
-              <td>[% L.input_tag('order.quonumber', SELF.order.quonumber, size = 11) %]</td>
-            [%- ELSE -%]
-              <td>[% L.input_tag('order.quonumber', SELF.order.quonumber, size = 11, onchange='kivi.Order.set_number_in_title(this)') %]</td>
-            [%- END -%]
+            <td>
+              [%- IF (SELF.type == "sales_order" || SELF.type == "purchase_order") -%]
+                [% L.input_tag('order.quonumber', SELF.order.quonumber, size = 11) %]
+              [%- ELSIF INSTANCE_CONF.get_sales_purchase_record_numbers_changeable %]
+                [% L.input_tag('order.quonumber', SELF.order.quonumber, size = 11, onchange='kivi.Order.set_number_in_title(this)') %]
+              [%- ELSIF SELF.order.id %]
+                [% HTML.escape(SELF.order.quonumber) %]
+                [% L.hidden_tag("order.quonumber", SELF.order.quonumber) %]
+              [% ELSE %]
+                [% LxERP.t8("will be set upon saving") %]
+              [%- END %]
+            </td>
           </tr>
 
           [%- IF (SELF.type == "sales_order" || SELF.type == "purchase_order") -%]