commit 5dbfda798e81aa0971a5e9c792f7c41a19d571b7
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Thu Jul 25 20:57:37 2019 +0200

    Neues Design 2019 Standard-Code templates/webpages/bank_transactions/_filter.html

diff --git a/templates/webpages/bank_transactions/_filter.html b/templates/webpages/bank_transactions/_filter.html
index 3e2f441e8..cf383d275 100644
--- a/templates/webpages/bank_transactions/_filter.html
+++ b/templates/webpages/bank_transactions/_filter.html
@@ -4,69 +4,65 @@
 [% USE HTML %]
 
 <form action='controller.pl' method='post' id='filter_form'>
-<div class='filter_toggle'>
-<a href='#' onClick='javascript:$(".filter_toggle").toggle()'>[% 'Show Filter' | $T8 %]</a>
-  [% SELF.filter_summary | html %]
-</div>
-<div class='filter_toggle' style='display:none'>
-<a href='#' onClick='javascript:$(".filter_toggle").toggle()'>[% 'Hide Filter' | $T8 %]</a>
- <table id='filter_table'>
+<div class="wrapper">
+
+[% BLOCK filter_toggle_panel %]
+<table id='filter_table' class="tbl-horizontal">
+  <tbody>
     <tr>
-     <th align="right">[% 'Bank account' | $T8 %]</th>
-     <td>[% L.select_tag('filter.local_bank_account_id', BANK_ACCOUNTS, default=filter.local_bank_account_id, title_key='displayable_name', with_empty=1, style='width:500px') %]</td>
+      <th>[% 'Bank account' | $T8 %]</th>
+      <td>[% L.select_tag('filter.local_bank_account_id', BANK_ACCOUNTS, default=filter.local_bank_account_id, title_key='displayable_name', with_empty=1, class='wi-verywide') %]</td>
     </tr>
-
     <tr>
-     <th align="right">[% 'Transdate from' | $T8 %]</th>
-     <td>[% L.date_tag('filter.transdate:date::ge', filter.transdate_date__ge) %]</td>
+      <th>[% 'Transdate from' | $T8 %]</th>
+      <td><span class="wi-date">[% L.date_tag('filter.transdate:date::ge', filter.transdate_date__ge) %]</span></td>
     </tr>
-
     <tr>
-     <th align="right">[% 'Transdate to' | $T8 %]</th>
-     <td>[% L.date_tag('filter.transdate:date::le', filter.transdate_date__le) %]</td>
+      <th>[% 'Transdate to' | $T8 %]</th>
+      <td><span class="wi-date">[% L.date_tag('filter.transdate:date::le', filter.transdate_date__le) %]</span></td>
     </tr>
-
     <tr>
-     <th align="right">[% 'Valutadate from' | $T8 %]</th>
-     <td>[% L.date_tag('filter.valutadate:date::ge', filter.valutadate_date__ge) %]</td>
+      <th>[% 'Valutadate from' | $T8 %]</th>
+      <td><span class="wi-date">[% L.date_tag('filter.valutadate:date::ge', filter.valutadate_date__ge) %]</span></td>
     </tr>
-
     <tr>
-     <th align="right">[% 'Valutadate to' | $T8 %]</th>
-     <td>[% L.date_tag('filter.valutadate:date::le', filter.valutadate_date__le) %]</td>
+      <th>[% 'Valutadate to' | $T8 %]</th>
+      <td><span class="wi-date">[% L.date_tag('filter.valutadate:date::le', filter.valutadate_date__le) %]</span></td>
     </tr>
-
     <tr>
-     <th align="right">[% 'Remote name' | $T8 %]</th>
-     <td>[% L.input_tag('filter.remote_name:substr::ilike', filter.remote_name_substr__ilike, size=60, class='initial_focus') %]</td>
+      <th>[% 'Remote name' | $T8 %]</th>
+      <td>[% L.input_tag('filter.remote_name:substr::ilike', filter.remote_name_substr__ilike, class='initial_focus wi-verywide') %]</td>
     </tr>
-
     <tr>
-     <th align="right">[% 'Remote account number' | $T8 %]</th>
-     <td>[% L.input_tag('filter.remote_account_number:substr::ilike', filter.remote_account_number_substr__ilike, size=60, class='initial_focus') %]</td>
+      <th>[% 'Remote account number' | $T8 %]</th>
+      <td>[% L.input_tag('filter.remote_account_number:substr::ilike', filter.remote_account_number_substr__ilike, class='initial_focus wi-verywide') %]</td>
     </tr>
-
     <tr>
-     <th align="right">[% 'Remote bank code' | $T8 %]</th>
-     <td>[% L.input_tag('filter.remote_bank_code:substr::ilike', filter.remote_bank_code_substr__ilike, size=60, class='initial_focus') %]</td>
+      <th>[% 'Remote bank code' | $T8 %]</th>
+      <td>[% L.input_tag('filter.remote_bank_code:substr::ilike', filter.remote_bank_code_substr__ilike, size=60, class='initial_focus wi-small') %]</td>
     </tr>
-
     <tr>
-     <th align="right">[% 'Amount' | $T8 %]</th>
-     <td>[% L.input_tag('filter.amount:number', filter.amount_number, size = 20) %]</td>
+      <th>[% 'Amount' | $T8 %]</th>
+      <td>[% L.input_tag('filter.amount:number', filter.amount_number, class="wi-small") %]</td>
     </tr>
-
     <tr>
-     <th align="right">[% 'Purpose' | $T8 %]</th>
-     <td>[% L.input_tag('filter.purpose:substr::ilike', filter.purpose_substr__ilike, size=60, class='initial_focus') %]</td>
+      <th>[% 'Purpose' | $T8 %]</th>
+      <td>[% L.input_tag('filter.purpose:substr::ilike', filter.purpose_substr__ilike, size=60, class='initial_focus wi-verywide') %]</td>
     </tr>
- </table>
+  </tbody>
+</table>
 
 [% L.hidden_tag('sort_by', FORM.sort_by) %]
 [% L.hidden_tag('sort_dir', FORM.sort_dir) %]
 [% L.hidden_tag('page', FORM.page) %]
-
-[% L.button_tag('$("#filter_form").resetForm()', LxERP.t8('Reset')) %]
+<div class="buttons">
+  [% L.button_tag('$("#filter_form").resetForm()', LxERP.t8('Reset'), class='neutral') %]
 </div>
+[% END %]
+
+
+[% INCLUDE 'common/toggle_panel.html'%]
+
+</div><!-- /.wrapper -->
 
 </form>