commit 1b803cbdc5f0945a1a942af25e85693a4d15346c
Author: Martin Helmling <martin.helmling@octosoft.eu>
Date:   Wed Nov 23 17:17:51 2016 +0100

    Alle neuen Features in das basis User-Menu

diff --git a/doc/UPGRADE b/doc/UPGRADE
index b92165ded..0f79ccbe6 100644
--- a/doc/UPGRADE
+++ b/doc/UPGRADE
@@ -28,6 +28,9 @@ Upgrade auf v3.4.x Unstable
   neue Spalte part_type vom ENUM-Typ, der auf die Werte 'part', 'service',
   'assembly' und 'assortment' beschränkt ist.
 
+* Die Tabelle hat eine neue Spalte classification_id die zu der neuen
+  Artikel-Klassifizierung Tabelle "parts_classifications" weist. 
+
 * In der Tabelle parts wurde die Spalten inventory_accno_id, expense_accno_id
   und income_accno_id entfernt. Deren Funktionalität wurde schon lange durch
   Buchungsgruppen ersetzt und für die Erkennung des Artikeltyps gibt es nun die
diff --git a/menus/user/00-erp.yaml b/menus/user/00-erp.yaml
index 8d8741fca..b48ac3e77 100644
--- a/menus/user/00-erp.yaml
+++ b/menus/user/00-erp.yaml
@@ -142,35 +142,15 @@
     action: CustomerVendor/search_contact
     db: customer
 - parent: master_data_reports
-  id: master_data_reports_parts
-  name: Parts
+  id: master_data_reports_articles
+  name: Articles
   icon: part_report
-  order: 400
-  access: part_service_assembly_details
-  module: ic.pl
-  params:
-    action: search
-    searchitems: part
-- parent: master_data_reports
-  id: master_data_reports_services
-  name: Services
-  icon: service_report
   order: 500
-  access: part_service_assembly_details
-  module: ic.pl
-  params:
-    action: search
-    searchitems: service
-- parent: master_data_reports
-  id: master_data_reports_assemblies
-  name: Assemblies
-  icon: assembly_report
-  order: 600
-  access: part_service_assembly_details
+  access: part_service_assembly_edit
   module: ic.pl
   params:
     action: search
-    searchitems: assembly
+    searchitems: article
 - parent: master_data_reports
   id: master_data_reports_assortments
   name: Assortments
@@ -574,6 +554,14 @@
   module: wh.pl
   params:
     action: journal
+- parent: warehouse_reports
+  id: warehouse_reports_whusage
+  name: WHUsage
+  icon: warehouse_usage
+  order: 300
+  access: warehouse_contents | warehouse_management
+  params:
+    action: Inventory/stock_usage
 - id: general_ledger
   name: General Ledger
   icon: gl
@@ -622,6 +610,14 @@
   access: general_ledger
   params:
     action: GoBD/filter
+- parent: general_ledger
+  id: general_ledger_cbob_transactions
+  name: CB/OB Transactions
+  icon: cbob
+  order: 470
+  access: general_ledger
+  params:
+    action: YearEndTransactions/filter
 - parent: general_ledger
   id: general_ledger_reports
   name: Reports
@@ -1101,6 +1097,13 @@
   module: am.pl
   params:
     action: edit_units
+- parent: system
+  id: system_parts_classification
+  name: Parts Classification
+  icon: partsclassific
+  order: 1150
+  params:
+    action: PartsClassification/list
 - parent: system
   id: system_price_factors
   name: Price Factors
diff --git a/menus/user/11-yearend-transactions.yaml b/menus/user/11-yearend-transactions.yaml
deleted file mode 100644
index 6906cdc89..000000000
--- a/menus/user/11-yearend-transactions.yaml
+++ /dev/null
@@ -1,16 +0,0 @@
-# This is the main menu config file for user space menu entries.
-#
-# opendynamic features
-#
----
-#
-# SB/EB-Buchungen
-#
-- parent: general_ledger
-  id: general_ledger_cbob_transactions
-  name: CB/OB Transactions
-  icon: cbob
-  order: 470
-  access: general_ledger
-  params:
-    action: YearEndTransactions/filter
diff --git a/menus/user/12-warehouse-usage.yaml b/menus/user/12-warehouse-usage.yaml
deleted file mode 100644
index 06b3c4c70..000000000
--- a/menus/user/12-warehouse-usage.yaml
+++ /dev/null
@@ -1,15 +0,0 @@
-#
-# opendynamic feature
-#
----
-#
-# Warenverbrauchsbericht
-#
-- parent: warehouse_reports
-  id: warehouse_reports_whusage
-  name: WHUsage
-  icon: warehouse_usage
-  order: 300
-  access: warehouse_contents | warehouse_management
-  params:
-    action: Inventory/stock_usage
diff --git a/menus/user/13-parts-classification.yaml b/menus/user/13-parts-classification.yaml
deleted file mode 100644
index 5cffd750d..000000000
--- a/menus/user/13-parts-classification.yaml
+++ /dev/null
@@ -1,14 +0,0 @@
-#
-# opendynamic features
-#
----
-#
-# parts classification
-#
-- parent: system
-  id: system_parts_classification
-  name: Parts Classification
-  icon: partsclassific
-  order: 1100
-  params:
-    action: PartsClassification/list
diff --git a/menus/user/14-one-part-edit-page.yaml b/menus/user/14-one-part-edit-page.yaml
deleted file mode 100644
index 730e76cee..000000000
--- a/menus/user/14-one-part-edit-page.yaml
+++ /dev/null
@@ -1,29 +0,0 @@
-#
-# opendynamic features
-#
----
-#
-# one edit page for parts,assemblies and services
-#
-#
-# first disable obsolete menu entries
-#
-- id: master_data_reports_parts
-  access: noaccess
-- id: master_data_reports_services
-  access: noaccess
-- id: master_data_reports_assemblies
-  access: noaccess
-#
-# new menu
-#
-- parent: master_data_reports
-  id: master_data_reports_articles
-  name: Articles
-  icon: part_report
-  order: 500
-  access: part_service_assembly_edit
-  module: ic.pl
-  params:
-    action: search
-    searchitems: article