commit 2e8b803f7f17f98556bc8791d9e838bf160a2518
Author: Bernd Bleßmann <bernd@kivitendo-premium.de>
Date:   Fri Feb 12 17:33:55 2016 +0100

    Kosmetik

diff --git a/bin/mozilla/ct.pl b/bin/mozilla/ct.pl
index 51b73249b..04fae4ee9 100644
--- a/bin/mozilla/ct.pl
+++ b/bin/mozilla/ct.pl
@@ -136,16 +136,16 @@ sub list_names {
     push @options, $locale->text('Orphaned');
   }
 
-  push @options, $locale->text('Name') . " : $form->{name}"                                    if $form->{name};
-  push @options, $locale->text('Contact') . " : $form->{contact}"                              if $form->{contact};
-  push @options, $locale->text('Number') . qq| : $form->{"$form->{db}number"}|                 if $form->{"$form->{db}number"};
-  push @options, $locale->text('E-mail') . " : $form->{email}"                                 if $form->{email};
-  push @options, $locale->text('Contact person (surname)')           . " : $form->{cp_name}"   if $form->{cp_name};
-  push @options, $locale->text('Billing/shipping address (city)')    . " : $form->{addr_city}" if $form->{addr_city};
-  push @options, $locale->text('Billing/shipping address (zipcode)') . " : $form->{addr_zipcode}"   if $form->{addr_zipcode};
-  push @options, $locale->text('Billing/shipping address (street)')  . " : $form->{addr_street}"    if $form->{addr_street};
-  push @options, $locale->text('Billing/shipping address (country)') . " : $form->{addr_country}"   if $form->{addr_country};
-  push @options, $locale->text('Billing/shipping address (GLN)')     . " : $form->{addr_gln}"  if $form->{addr_gln};
+  push @options, $locale->text('Name') . " : $form->{name}"                                       if $form->{name};
+  push @options, $locale->text('Contact') . " : $form->{contact}"                                 if $form->{contact};
+  push @options, $locale->text('Number') . qq| : $form->{"$form->{db}number"}|                    if $form->{"$form->{db}number"};
+  push @options, $locale->text('E-mail') . " : $form->{email}"                                    if $form->{email};
+  push @options, $locale->text('Contact person (surname)')           . " : $form->{cp_name}"      if $form->{cp_name};
+  push @options, $locale->text('Billing/shipping address (city)')    . " : $form->{addr_city}"    if $form->{addr_city};
+  push @options, $locale->text('Billing/shipping address (zipcode)') . " : $form->{addr_zipcode}" if $form->{addr_zipcode};
+  push @options, $locale->text('Billing/shipping address (street)')  . " : $form->{addr_street}"  if $form->{addr_street};
+  push @options, $locale->text('Billing/shipping address (country)') . " : $form->{addr_country}" if $form->{addr_country};
+  push @options, $locale->text('Billing/shipping address (GLN)')     . " : $form->{addr_gln}"     if $form->{addr_gln};
 
   if ($form->{business_id}) {
     my $business = SL::DB::Manager::Business->find_by(id => $form->{business_id});
diff --git a/templates/webpages/ct/search.html b/templates/webpages/ct/search.html
index d98b324ce..10a6ceaae 100644
--- a/templates/webpages/ct/search.html
+++ b/templates/webpages/ct/search.html
@@ -35,10 +35,10 @@
     <th align="right" nowrap>[% 'Billing/shipping address (street)' | $T8 %]</th>
     <td><input name="addr_street" size="35"></td>
    </tr>
- <tr>
+   <tr>
     <th align="right" nowrap>[% 'Billing/shipping address (zipcode)' | $T8 %]</th>
     <td><input name="addr_zipcode" size="35"></td>
- </tr>
+   </tr>
    <tr>
     <th align="right" nowrap>[% 'Billing/shipping address (city)' | $T8 %]</th>
     <td><input name="addr_city" size="35"></td>
@@ -176,7 +176,7 @@
        <td>
         <input name="l_country" id="l_country" type="checkbox" class="checkbox" value="Y" checked>
         <label for="l_country">[% 'Country' | $T8 %]</label>
-      </td>
+       </td>
       </tr>
       <tr>
        <td>
@@ -198,14 +198,14 @@
       </tr>
       [% IF IS_CUSTOMER %]
       <tr>
-      <td>
-       <input name="l_salesman" id="l_salesman" type="checkbox" class="checkbox" value="Y">
-       <label for="l_salesman">[% 'Salesman' | $T8 %]</label>
-      </td>
-      <td>
-       <input name="l_pricegroup" id="l_pricegroup" type="checkbox" class="checkbox" value="Y">
-       <label for="l_pricegroup">[% 'Pricegroup' | $T8 %]</label>
-      </td>
+       <td>
+        <input name="l_salesman" id="l_salesman" type="checkbox" class="checkbox" value="Y">
+        <label for="l_salesman">[% 'Salesman' | $T8 %]</label>
+       </td>
+       <td>
+        <input name="l_pricegroup" id="l_pricegroup" type="checkbox" class="checkbox" value="Y">
+        <label for="l_pricegroup">[% 'Pricegroup' | $T8 %]</label>
+       </td>
       </tr>
       [% END %]
 